searchNodes=[{"doc":"Stream standard I/O from system processes. Overview Stdio manages system processes. The process standard output ( stdout ) and standard error ( stderr ) are represented as Stream 's of stdio/0 tuples. Standard input ( stdin ) can be piped into using a binary stream. system processes run as foreground processes when the foreground process exits, daemonized and background subprocesses are reliably terminated system processes are optionally restricted using behaviours such as Stdio.Container , Stdio.Rootless or Stdio.Jail Streaming stdout/stderr A simple example of creating a stream using Stdio.stream!/1 : iex&gt; Stdio . stream! ( &quot;echo hello; echo world &gt;&amp;2&quot; ) |&gt; Enum . to_list ( ) [ stdout : &quot;hello \\n &quot; , stderr : &quot;world \\n &quot; , exit_status : 0 ] Piping stdin An example of using a system process to transform a stream using Stdio.pipe!/2 : iex&gt; [ &quot;hello \\n &quot; ] |&gt; Stdio . pipe! ( &quot;sed -u &#39;s/hello/bye/&#39;&quot; ) |&gt; Enum . to_list ( ) [ stdout : &quot;bye \\n &quot; , exit_status : 0 ] Unbuffer Output Process output may be buffered. The pipe example unbuffers the output by using the -u option of sed(1) . Privileges Warning Some behaviours, notably Stdio.Container and Stdio.Jail , require the system supervisor (not the beam process!) to be running as the root user. See setuid/0 for instructions on how to set it up. Behaviours may change the root filesystem for the process. The default chroot(2) directory hierarchy can be created by running: iex&gt; Stdio.Container . make_chroot_tree! ( ) :ok Process Capabilities and Namespaces Stdio behaviours can restrict system process capabilities or isolate the process using namespaces or jails. The default implementation uses the standard fork(2) 'ing process model. Other implementations are Stdio.Container (Linux namespaces(7) ), Stdio.Rootless (Linux user_namespaces(7) ) and Stdio.Jail (FreeBSD jail(2) iex&gt; Stdio . stream! ( &quot;id -u&quot; , Stdio.Rootless ) |&gt; Enum . to_list ( ) [ stdout : &quot;65534 \\n &quot; , exit_status : 0 ] Supervising System Processes Stdio processes can be supervised and restarted by a Task.Supervisor : Supervisor . start_link ( [ { Task.Supervisor , name : Init.TaskSupervisor } ] , strategy : :one_for_one ) To create and supervise a system process: require Logger Task.Supervisor . start_child ( Init.TaskSupervisor , fn -&gt; Stdio . stream! ( &quot;nc -l 4545&quot; ) |&gt; Stream . each ( fn { :stdout , e } -&gt; Logger . info ( e ) { :stderr , e } -&gt; Logger . error ( e ) e -&gt; Logger . warn ( &quot; \#{ inspect ( e ) } &quot; ) end ) |&gt; Stream . run ( ) end , restart : :permanent ) In another shell, connect to port 4545 and send some data: $ nc localhost 4545 test 123 ^C $ nc localhost 4545 netcat was restarted by the supervisor! ^C In iex : 05 : 40 : 26.277 [ info ] test 05 : 40 : 27.669 [ info ] 123 05 : 40 : 28.044 [ warning ] { :exit_status , 0 } 05 : 40 : 52.929 [ info ] netcat was restarted by the supervisor! 05 : 40 : 53.451 [ warning ] { :exit_status , 0 }","ref":"Stdio.html","title":"Stdio","type":"behaviour"},{"doc":"Function to fork(2) a system subprocess from the supervisor created by the task/1 callback. In a PID namespace, this process will be the init process or PID 1.","ref":"Stdio.html#c:init/1","title":"Stdio.init/1","type":"callback"},{"doc":"Function run on operation error. onerror/1 runs if any of the operations defined in ops/1 returns an error. An error is an error tuple: { :error , :prx . posix ( ) } The return value of onerror/1 is ignored. Exceptions within the callback are not handled by default and may terminate the linked process. The supervisor process for the task can be found by calling :prx.parent/1 . For example, to signal the process group: supervisor = :prx . parent ( sh ) :prx . kill ( supervisor , 0 , :SIGTERM )","ref":"Stdio.html#c:onerror/1","title":"Stdio.onerror/1","type":"callback"},{"doc":"Function run during stream termination. onexit/1 runs when the stream is closed. The function can perform clean up and signal any lingering processses. Returns true if subprocesses were found to be running during cleanup.","ref":"Stdio.html#c:onexit/1","title":"Stdio.onexit/1","type":"callback"},{"doc":"A sequence of Stdio.Op.t()/0 instructions for a system process. Operations are defined in prx but any module can be called by specifying the module name.","ref":"Stdio.html#c:ops/1","title":"Stdio.ops/1","type":"callback"},{"doc":"Pipe data into the standard input of a system process. Input is a stream of binaries. Empty binaries are ignored. See stream!/3 for arguments. Examples iex&gt; Stream . unfold ( 1000 , fn 0 -&gt; nil ; n -&gt; { &quot; \#{ n } \\n &quot; , n - 1 } end ) ...&gt; |&gt; Stdio . pipe! ( &quot;grep --line-buffered 442&quot; ) ...&gt; |&gt; Enum . to_list ( ) [ stdout : &quot;442 \\n &quot; , exit_status : 0 ] iex&gt; Stdio . stream! ( &quot;echo test; kill $$&quot; ) iex&gt; |&gt; Stream . transform ( &lt;&lt; &gt;&gt; , &amp; Stdio.Stream . stdout_to_stderr / 2 ) iex&gt; |&gt; Stdio . pipe! ( &quot;sed -u &#39;s/t/_/g&#39;&quot; ) iex&gt; |&gt; Enum . to_list ( ) [ stdout : &quot;_es_ \\n &quot; , exit_status : 0 ] iex&gt; [ &lt;&lt; &gt;&gt; , &lt;&lt; &quot;a&quot; &gt;&gt; , &lt;&lt; &gt;&gt; ] |&gt; Stdio . pipe! ( &quot;cat&quot; ) |&gt; Enum . to_list ( ) [ stdout : &quot;a&quot; , exit_status : 0 ]","ref":"Stdio.html#pipe!/4","title":"Stdio.pipe!/4","type":"function"},{"doc":"Terminate descendents of a supervisor process.","ref":"Stdio.html#reap/2","title":"Stdio.reap/2","type":"function"},{"doc":"Terminate descendents of a process. reap signals subprocesses of a process identified by PID. Background and daemonized subprocesses will also be terminated if supported by the platform.","ref":"Stdio.html#reap/3","title":"Stdio.reap/3","type":"function"},{"doc":"Request system supervisor runs as root. Some system calls require the process to be UID 0. These calls typically are operations like mounting filesystems or creating new namespaces (excluding user namespaces such as Stdio.Rootless ) or putting a process into a jail(2) or a chroot(2) . Warning Enabling privileges is a global setting: all system supervisor processes will run as UID 0. Setuid Binary Probably the simplest method for production use is adding the setuid bit to the prx binary (see :prx_drv.progname/0 ): create a group with privileges to run the supervisor (optional) # example: create an elixir group groupadd elixir find the location of the binary :prx_drv . progname ( ) set the setuid bit sudo chown root :elixir / path / to / priv / prx sudo chmod 4750 / path / to / priv / prx Using a Setuid Exec Chain prx can be configured to use a setuid helper program such as sudo(8) or doas(1) . Stdio.setuid/0 is a noop if the prx binary is setuid. Before launching any supervisors, run: Stdio . setuid ( ) sudo(8) $ sudo visudo elixiruser ALL = NOPASSWD : / path / to / prx / priv / prx Defaults ! / path / to / prx / priv / prx ! requiretty doas(8) permit nopass setenv { ENV PS1 SSH_AUTH_SOCK } :elixirgroup","ref":"Stdio.html#setuid/0","title":"Stdio.setuid/0","type":"function"},{"doc":"Stream standard I/O from system processes. command Commands are strings interpreted by /bin/sh or list of strings (an argv) passed directly to execve(2) . Warning When using an argv, $PATH is not consulted. The path to the executable must be provided as the first argument. behaviour The process behaviour can be customized by passing in: a module implementing the callbacks a keyword list with functions of type phase/0 a tuple consisting of a module and a list of phase/0 functions to override the module callbacks config For configuration options, see config/0 . Examples iex&gt; Stdio . stream! ( &quot;echo test&quot; ) |&gt; Enum . to_list ( ) [ stdout : &quot;test \\n &quot; , exit_status : 0 ] iex&gt; Stdio . stream! ( [ &quot;/bin/echo&quot; , &quot;test&quot; ] ) |&gt; Enum . to_list ( ) [ stdout : &quot;test \\n &quot; , exit_status : 0 ] iex&gt; Stdio . stream! ( &quot;ip --oneline -4 addr show dev lo&quot; , Stdio.Container ) |&gt; Enum . to_list ( ) [ exit_status : 0 ] iex&gt; Stdio . stream! ( &quot;ip --oneline -4 addr show dev lo&quot; , Stdio.Container , net : :host ) |&gt; Enum . to_list ( ) [ stdout : &quot;1: lo inet 127.0.0.1/8 scope host lo \\\\ valid_lft forever preferred_lft forever \\n &quot; , exit_status : 0 ] iex&gt; Stdio . stream! ( &quot;pwd&quot; , { Stdio.Process , ops : fn _ -&gt; [ { :chdir , [ &quot;/tmp&quot; ] } ] end } ) |&gt; Enum . to_list ( ) [ stdout : &quot;/tmp \\n &quot; , exit_status : 0 ]","ref":"Stdio.html#stream!/3","title":"Stdio.stream!/3","type":"function"},{"doc":"Configure a task to be a system process supervisor. The task: becomes an init process (dependent on platform) sets the process name to supervise enables flow control for child stdout/stderr sets the shutdown/reaper behaviour terminates child processes if beam exits restricts the task to a limited set of calls required for supervision","ref":"Stdio.html#supervise/3","title":"Stdio.supervise/3","type":"function"},{"doc":"Create a supervisor task Returns a Stdio.t/0 configured to act as a system process supervisor.","ref":"Stdio.html#supervisor/2","title":"Stdio.supervisor/2","type":"function"},{"doc":"Function to create a system supervisor for the stream. Create a task using :prx.fork/0 and configured as a process supervisor. See supervise/1 for the default operations.","ref":"Stdio.html#c:task/1","title":"Stdio.task/1","type":"callback"},{"doc":"Use a previously created supervisor process. The supervisor is not shutdown when the stream exits. Examples iex&gt; { :ok , supervisor } = Stdio . supervisor ( ) iex&gt; Stdio . stream! ( &quot;echo test&quot; , Stdio . with_supervisor ( Stdio.Process , supervisor ) ) |&gt; Enum . to_list ( ) [ stdout : &quot;test \\n &quot; , exit_status : 0 ] iex&gt; Stdio . stream! ( &quot;echo test&quot; , Stdio . with_supervisor ( Stdio.Process , supervisor ) ) |&gt; Enum . to_list ( ) [ stdout : &quot;test \\n &quot; , exit_status : 0 ] iex&gt; :prx . stop ( supervisor . init ) graph LR B([beam]) --&gt; S[Supervise] S -.-&gt; I0[[sh]] S --&gt; I1[[sh]] I0 -.-&gt; C0[[echo test]] I1 --&gt; C1[[echo test]]","ref":"Stdio.html#with_supervisor/2","title":"Stdio.with_supervisor/2","type":"function"},{"doc":"Configuration options for callbacks: net Defines the network capability for behaviours with support for network namespaces. none: process does not have access to network host: process shares the host's network namespace environ Set the process environment using a list of = separated strings. iex&gt; Stdio . stream! ( [ &quot;/usr/bin/env&quot; ] , Stdio.Process , environ : [ &quot;TERM=dumb&quot; , &quot;PATH=/bin&quot; ] ) |&gt; Enum . to_list ( ) [ stdout : &quot;TERM=dumb \\n PATH=/bin \\n &quot; , exit_status : 0 ] uid Requires setuid/0 Set the UID of the subprocess. If not set, a UID is generated by the behaviour. gid Requires setuid/0 Set the GID of the subprocess. If not set, a GID is generated by the behaviour. groups Requires setuid/0 Set a list of additional groups (a list of GIDs) for the subprocess. By default, additional groups are dropped. fstab Requires setuid/0 A list of directories to bind mount inside of the container namespace. Relative paths are resolved relative to the application priv directory. path May require setuid/0 Sets the working directory of the subprocess. Behaviours changing the root directory use path as the root. hostname Requires setuid/0 Sets the hostname of the process. setuid If set to false (the default), drops privileges before running the command. priority Sets the process priority (default: 0). rlimit A map containing setrlimit(2) settings. The default disables core dumps.","ref":"Stdio.html#t:config/0","title":"Stdio.config/0","type":"type"},{"doc":"Phases are functions defining how a process is forked, configured and supervised. Phases can be implemented as a behaviour or as a list of functions. stateDiagram-v2 direction LR [*] --&gt; Supervisor: fork(2) Supervisor --&gt; Subprocess: fork(2) Subprocess --&gt; Terminate: stream Terminate --&gt; [*] state Supervisor { direction LR [*] --&gt; task task --&gt; [*] } state Subprocess { state result &lt;&lt;choice&gt;&gt; direction LR [*] --&gt; init init --&gt; ops ops --&gt; result result --&gt; [*]: ok result --&gt; onerror: {error, posix()} } state Terminate { direction LR onexit --&gt; [*] } task Returns a :prx.task/0 system process configured to act as a system process supervisor. init Forks and initializes a subprocess of the system process supervisor. When using namespaces, this process will be PID 1 or the container init process. ops Provides a sequence of system calls to perform on the subprocess onerror Function called to clean up if any of the operations defined in ops/1 fail. onexit Function called when the stream is closed.","ref":"Stdio.html#t:phase/0","title":"Stdio.phase/0","type":"type"},{"doc":"","ref":"Stdio.html#t:pipeline/0","title":"Stdio.pipeline/0","type":"type"},{"doc":"Tuples containing the process stdout, stderr and termination status. :stdout : standard output :stderr : standard error :exit_status : process has exited with status value :termsig : the termination signal if the process exited due to a signal","ref":"Stdio.html#t:stdio/0","title":"Stdio.stdio/0","type":"type"},{"doc":"","ref":"Stdio.html#t:t/0","title":"Stdio.t/0","type":"type"},{"doc":"Namespaced Linux processes Run a process in a Linux namespace . Privileges To use this behaviour, the system process supervisor must have root privileges. These privileges are dropped before running the command. Root privileges can be enabled by setting the setuid bit on the prx executable or by running it under a program like sudo(8) . Operations Mount Namespace Root (chroot) Directory The chroot directory structure must be created before using this behaviour. See make_chroot_tree!/0 and make_chroot_tree!/1 . See Stdio.config/0 for configuration options. creates a process in a new UTS, IPC, PID, mount and by default, net namespace creates a new session sets the process priority [:priority=0] bind mounts as read-only /bin, /sbin, /usr, /lib and the list specified in fstab into the container mount namespace mounts /tmp and /home as tmpfs filesystems changes the mount namespace root directory to the chroot sets resource limits defined in the rlimit option [:rlimit=disable coredumps] sends the process a SIGKILL if the parent process exits sets additional groups as specified in the group option [:groups=remove additional groups] drops privileges to the value of uid and gid or a high UID system user [:uid/:gid=65536-131071] disables the ability of the process to escalate privileges [:setuid=false] Warning The generated UID/GID may overlap with existing users. Examples iex&gt; Stdio . stream! ( &quot;pstree&quot; , Stdio.Container ) |&gt; Enum . to_list ( ) [ stdout : &quot;sh---pstree \\n &quot; , exit_status : 0 ]","ref":"Stdio.Container.html","title":"Stdio.Container","type":"module"},{"doc":"Create the container root directory structure. Creates the directory structure set in the application environment. The default is: # the default is set to the application priv directory: priv/root config :stdio , path : &quot;/tmp/root&quot;","ref":"Stdio.Container.html#make_chroot_tree!/0","title":"Stdio.Container.make_chroot_tree!/0","type":"function"},{"doc":"See make_chroot_tree!/0","ref":"Stdio.Container.html#make_chroot_tree!/1","title":"Stdio.Container.make_chroot_tree!/1","type":"function"},{"doc":"Jailed FreeBSD processes Runs a process in a jail(2) . Privileges To use this behaviour, the system process supervisor must have root privileges. These privileges are dropped before running the command. See Stdio.setuid/0 . sysctl(8) sysctl(8) settings control the behaviour of the jail. For example, to allow ping/traceroute from the jail: sysctl security . jail . allow_raw_sockets = 1 See jail(8) . Operations See Stdio.config/0 for configuration options. creates a new session sets the process priority [:priority=0] puts the process into a jail(2) sets resource limits [:rlimit=coredumps disabled] sets additional groups [:groups=additional groups removed] drops privileges to the value of uid and gid or a high UID system user [:uid/:gid=65536-131071] disables the capability to elevate privileges [:setuid=false] Warning The generated UID/GID may overlap with existing users. Examples iex&gt; Stdio . stream! ( [ &quot;./echo&quot; , &quot;test&quot; ] , Stdio.Jail , path : &quot;/rescue&quot; ) ...&gt; |&gt; Enum . to_list ( ) [ stdout : &quot;test \\n &quot; , exit_status : 0 ] iex&gt; Stdio . stream! ( ...&gt; [ &quot;sh&quot; , &quot;-c&quot; , &quot;export PATH=/; ping -c 1 127.0.0.1 | head -1&quot; ] , ...&gt; Stdio.Jail , ...&gt; uid : 0 , path : &quot;/rescue&quot; , setuid : true , net : :host ...&gt; ) |&gt; Enum . to_list ( ) [ stdout : &quot;PING 127.0.0.1 (127.0.0.1): 56 data bytes \\n &quot; , exit_status : 0 ]","ref":"Stdio.Jail.html","title":"Stdio.Jail","type":"module"},{"doc":"Run a sequence of system calls on a process","ref":"Stdio.Op.html","title":"Stdio.Op","type":"module"},{"doc":"Creates and configures a new process from the supervisor process.","ref":"Stdio.Op.html#task!/4","title":"Stdio.Op.task!/4","type":"function"},{"doc":"Options to modify the behavior of an operation: state : pass ok result as the first parameter to the next operation (default: false) errexit : abort operations on error (default: true) transform : abort operations on error (default: true)","ref":"Stdio.Op.html#t:option/0","title":"Stdio.Op.option/0","type":"type"},{"doc":"Operations consist of a list of tuples containing: an optional module name (default: :prx ) a function name a list of arguments an optional list of options to modify the behaviour of the operation (see t:option ) Examples { :setresuid , [ 1000 , 1000 , 1000 ] } { :prx , :setresuid , [ 1000 , 1000 , 1000 ] } { :prx , :setresuid , [ 1000 , 1000 , 1000 ] , errexit : false }","ref":"Stdio.Op.html#t:t/0","title":"Stdio.Op.t/0","type":"type"},{"doc":"Supervised system processes fork(2) new system processes. Privileges No additional privileges required. If the Stdio supervisor process is running as root, supervised processes will by default drop to an unprivileged user. Operations See Stdio.config/0 for configuration options. creates a new session sets the process priority [:priority=0] sets resource limits defined in the rlimit option [:rlimit=coredumps disabled] sends the process a SIGKILL if the parent process exits If the system process is running with root privileges: sets additional groups as specified in the group option [:groups=additional groups removed] drops privileges to the value of uid and gid or a high UID system [:uid/gid=65536-131071] disables the ability of the process to escalate privileges [:setuid=false] Warning The generated UID/GID may overlap with existing users. Examples iex&gt; Stdio . stream! ( ...&gt; &quot;ping -q -c 1 127.0.0.1 | grep -o PING&quot; , ...&gt; Stdio.Process , ...&gt; setuid : true ...&gt; ) |&gt; Enum . to_list ( ) [ stdout : &quot;PING \\n &quot; , exit_status : 0 ]","ref":"Stdio.Process.html","title":"Stdio.Process","type":"module"},{"doc":"Test if a Stdio process is running","ref":"Stdio.Process.html#alive?/1","title":"Stdio.Process.alive?/1","type":"function"},{"doc":"Signal a process by process group, falling back to PID","ref":"Stdio.Process.html#signal/3","title":"Stdio.Process.signal/3","type":"function"},{"doc":"System process supervisor tree.","ref":"Stdio.ProcessTree.html","title":"Stdio.ProcessTree","type":"module"},{"doc":"","ref":"Stdio.ProcessTree.html#task/1","title":"Stdio.ProcessTree.task/1","type":"function"},{"doc":"","ref":"Stdio.ProcessTree.html#t:t/0","title":"Stdio.ProcessTree.t/0","type":"type"},{"doc":"Read data from procfs .","ref":"Stdio.Procfs.html","title":"Stdio.Procfs","type":"module"},{"doc":"Get descendents of a process. Child processes are enumerated by reading proc(5) : if the Linux kernel was compiled with CONFIG_PROC_CHILDREN , the /proc/[pid]/task/[pid]/children file is read otherwise, children/1 falls back to walking /proc Examples iex&gt; Stdio.Procfs . children ( 0 ) |&gt; Enum . sort ( ) |&gt; List . first ( ) 1","ref":"Stdio.Procfs.html#children/2","title":"Stdio.Procfs.children/2","type":"function"},{"doc":"Return a snapshot of the current system processes. Generates a snapshot of running system processes by walking the procfs filesystem (usually mounted as /proc ). The returned value is a map list of key/value pairs read from /proc/[pid]/status . Examples iex&gt; pid = Stdio.Procfs . ps ( ) |&gt; Enum . sort ( &amp; ( &amp;1 [ &quot;ppid&quot; ] &lt; &amp;2 [ &quot;ppid&quot; ] ) ) |&gt; List . first ( ) iex&gt; pid [ &quot;pid&quot; ] &quot;1&quot;","ref":"Stdio.Procfs.html#ps/1","title":"Stdio.Procfs.ps/1","type":"function"},{"doc":"","ref":"Stdio.Procfs.html#t:t/0","title":"Stdio.Procfs.t/0","type":"type"},{"doc":"Linux processes running in a user namespace. Proof of concept behaviour to run &quot;rootless&quot; Linux processes or processes that have root privileges in a user namespace . Privileges No extra privileges are required but user namespaces must be enabled on your platform: $ sysctl kernel.unprivileged_userns_clone kernel.unprivileged_userns_clone = 1 # to enable: $ sysctl -w kernel.unprivileged_userns_clone=1 Operations Mount Namespace Root (chroot) Directory The chroot directory structure must be created before using this behaviour. See Stdio.Container.make_chroot_tree!/0 and Stdio.Container.make_chroot_tree!/1 . See Stdio.config/0 for configuration options. Examples iex&gt; Stdio . stream! ( &quot;pstree&quot; , Stdio.Rootless ) |&gt; Enum . to_list ( ) [ stdout : &quot;Supervise---sh---pstree \\n &quot; , exit_status : 0 ] iex(1)&gt; Stdio . stream! ( &quot;ip --oneline -4 addr show dev lo&quot; , Stdio.Rootless , net : :host , setuid : true ) |&gt; Enum . to_list ( ) [ stdout : &quot;1: lo inet 127.0.0.1/8 scope host lo \\\\ valid_lft forever preferred_lft forever \\n &quot; , exit_status : 0 ]","ref":"Stdio.Rootless.html","title":"Stdio.Rootless","type":"module"},{"doc":"Stream standard I/O from system processes","ref":"Stdio.Stream.html","title":"Stdio.Stream","type":"module"},{"doc":"Rate limits a stream by discarding elements exceeding a threshold for the remainder of the window. ratelimit/3 works with any Enumerable.t . For working with streams generated by Stdio , see ratelimit/4 . Examples iex&gt; Stream . unfold ( 1_000 , fn 0 -&gt; nil ; n -&gt; { n , n - 1 } end ) ...&gt; |&gt; Stdio.Stream . ratelimit ( 2 , 10_000 ) ...&gt; |&gt; Enum . to_list ( ) [ 1000 , 999 ]","ref":"Stdio.Stream.html#ratelimit/3","title":"Stdio.Stream.ratelimit/3","type":"function"},{"doc":"Rate limits a stream by calling a function on each event. The function is a reducer for Stream.transform/3 which is passed the rate limit state in the accumulator: t: window start time limit: window threshold ms: window duration in milliseconds The function maintains a count of matching events and enables rate limiting when the threshold is exceeded for the window. See stdio_block/2 and stdio_drop/2 for functions which can apply back pressure to or drop events from Stdio.stream!/1 or Stdio.pipe!/2 .","ref":"Stdio.Stream.html#ratelimit/4","title":"Stdio.Stream.ratelimit/4","type":"function"},{"doc":"Apply back pressure on Stdio.stream!/1 or Stdio.pipe!/2 using ratelimit/4 by blocking further reads if the rate of stdout/stderr exceeds the threshold. Output accumulates until the process pipe buffer is full. Further writes are blocked. Control events (process exit and termination signals) are not counted against the threshold. Warning When the rate limit is reached, the stream is blocked for the remainder of the window, even if the system process has exited. To see how it works, try running: require Logger Stdio . stream! ( &quot;while :; do date; done&quot; ) |&gt; Stdio.Stream . ratelimit ( 1 , 5_000 , &amp; Stdio.Stream . stdio_block / 2 ) |&gt; Stream . each ( fn t -&gt; t |&gt; inspect ( ) |&gt; Logger . info ( ) end ) |&gt; Enum . take ( 15 ) The output from Logger will be spaced 5 seconds apart. The data from Stdio.stream!/1 is buffered: 00 : 11 : 56.410 [ info ] { :stdout , &quot;Thu Jul 7 00:11:51 EDT 2022 \\n &quot; } 00 : 12 : 01.410 [ info ] { :stdout , &quot;Thu Jul 7 00:11:51 EDT 2022 \\n &quot; } 00 : 12 : 06.412 [ info ] { :stdout , &quot;Thu Jul 7 00:11:51 EDT...&quot; } Examples iex&gt; Stdio . stream! ( &quot;echo 1&quot; ) ...&gt; |&gt; Stdio.Stream . ratelimit ( 1 , 2_000 , &amp; Stdio.Stream . stdio_block / 2 ) ...&gt; |&gt; Enum . to_list ( ) [ stdout : &quot;1 \\n &quot; , exit_status : 0 ]","ref":"Stdio.Stream.html#stdio_block/2","title":"Stdio.Stream.stdio_block/2","type":"function"},{"doc":"Rate limit output of Stdio.stream!/1 or Stdio.pipe!/2 using ratelimit/4 by dropping events if the rate of stdout/stderr exceeds the threshold. Control events (process exit and termination signals) are always passed through. To see how it works, try running: require Logger Stdio . stream! ( &quot;while :; do date; done&quot; ) |&gt; Stdio.Stream . ratelimit ( 1 , 5_000 , &amp; Stdio.Stream . stdio_drop / 2 ) |&gt; Stream . each ( fn t -&gt; t |&gt; inspect ( ) |&gt; Logger . info ( ) end ) |&gt; Enum . take ( 15 ) The output from Logger will be spaced 5 seconds apart. Rate limited data from Stdio.stream!/1 is dropped: 00 : 17 : 22.058 [ info ] { :stdout , &quot;Thu Jul 7 00:17:22 EDT 2022 \\n &quot; } 00 : 17 : 27.059 [ info ] { :stdout , &quot;Thu Jul 7 00:17:27 EDT 2022 \\n &quot; } 00 : 17 : 32.060 [ info ] { :stdout , &quot;Thu Jul 7 00:17:32 EDT 2022 \\n &quot; } 00 : 17 : 37.061 [ info ] { :stdout , &quot;Thu Jul 7 00:17:37 EDT 2022 \\n &quot; } Examples iex&gt; Stdio . stream! ( &quot;echo 1&quot; ) ...&gt; |&gt; Stdio.Stream . ratelimit ( 1 , 2_000 , &amp; Stdio.Stream . stdio_drop / 2 ) ...&gt; |&gt; Enum . to_list ( ) [ stdout : &quot;1 \\n &quot; , exit_status : 0 ]","ref":"Stdio.Stream.html#stdio_drop/2","title":"Stdio.Stream.stdio_drop/2","type":"function"},{"doc":"Combine standard error into the standard output of Stdio.stream!/1 or Stdio.pipe!/2 and emit a list of binaries. Exit status and termination signals are not included in the output. Examples iex&gt; Stdio . stream! ( &quot;echo output; echo error 1&gt;&amp;2; exit 1&quot; ) ...&gt; |&gt; Stream . transform ( [ ] , &amp; Stdio.Stream . stdout_to_stderr / 2 ) ...&gt; |&gt; Enum . to_list ( ) [ &quot;output \\n &quot; , &quot;error \\n &quot; ]","ref":"Stdio.Stream.html#stdout_to_stderr/2","title":"Stdio.Stream.stdout_to_stderr/2","type":"function"},{"doc":"","ref":"Stdio.Stream.html#t:t/0","title":"Stdio.Stream.t/0","type":"type"},{"doc":"System call portability for operating systems.","ref":"Stdio.Syscall.html","title":"Stdio.Syscall","type":"behaviour"},{"doc":"The default implementation for disable_setuid/0 Disabling the ability for the process to escalate privileges is not available on this platform.","ref":"Stdio.Syscall.html#disable_setuid/0","title":"Stdio.Syscall.disable_setuid/0","type":"function"},{"doc":"Operations required to disable setuid.","ref":"Stdio.Syscall.html#c:disable_setuid/0","title":"Stdio.Syscall.disable_setuid/0","type":"callback"},{"doc":"Get the syscall implementation for this platform. The default implementation is based on the operating system. Set the implementation by configuring the application environment: import Config config :stdio , :syscall , Stdio.Syscall.Linux","ref":"Stdio.Syscall.html#os/0","title":"Stdio.Syscall.os/0","type":"function"},{"doc":"The default implementation for procfs/0","ref":"Stdio.Syscall.html#procfs/0","title":"Stdio.Syscall.procfs/0","type":"function"},{"doc":"Path to procfs file system","ref":"Stdio.Syscall.html#c:procfs/0","title":"Stdio.Syscall.procfs/0","type":"callback"},{"doc":"Terminating descendents of a supervisor process","ref":"Stdio.Syscall.html#reap/2","title":"Stdio.Syscall.reap/2","type":"function"},{"doc":"Terminate descendents of a supervisor process.","ref":"Stdio.Syscall.html#c:reap/2","title":"Stdio.Syscall.reap/2","type":"callback"},{"doc":"Terminate descendents of a process. Signals the process group for each child process.","ref":"Stdio.Syscall.html#reap/3","title":"Stdio.Syscall.reap/3","type":"function"},{"doc":"Terminate a process subtree (descendents of a child process) of the supervisor.","ref":"Stdio.Syscall.html#c:reap/3","title":"Stdio.Syscall.reap/3","type":"callback"},{"doc":"The default implementation for set_pdeathsig/0 Signalling a process when the parent has exited is not available on this platform.","ref":"Stdio.Syscall.html#set_pdeathsig/0","title":"Stdio.Syscall.set_pdeathsig/0","type":"function"},{"doc":"Operations required to terminate a process if the parent exits.","ref":"Stdio.Syscall.html#c:set_pdeathsig/0","title":"Stdio.Syscall.set_pdeathsig/0","type":"callback"},{"doc":"The default implementation for setproctitle/2 Uses :prx.setproctitle/2 on all platforms.","ref":"Stdio.Syscall.html#setproctitle/2","title":"Stdio.Syscall.setproctitle/2","type":"function"},{"doc":"Set the process title.","ref":"Stdio.Syscall.html#c:setproctitle/2","title":"Stdio.Syscall.setproctitle/2","type":"callback"},{"doc":"The default implementation for subreaper/1 No changes are made to the process: background processes will not be terminated.","ref":"Stdio.Syscall.html#subreaper/1","title":"Stdio.Syscall.subreaper/1","type":"function"},{"doc":"Set process as init(1) for descendent processes.","ref":"Stdio.Syscall.html#c:subreaper/1","title":"Stdio.Syscall.subreaper/1","type":"callback"},{"doc":"System call portability for FreeBSD","ref":"Stdio.Syscall.FreeBSD.html","title":"Stdio.Syscall.FreeBSD","type":"module"},{"doc":"FreeBSD procfs support using the Linux compatible procfs. See linprocfs","ref":"Stdio.Syscall.FreeBSD.html#procfs/0","title":"Stdio.Syscall.FreeBSD.procfs/0","type":"function"},{"doc":"System call portability for Linux.","ref":"Stdio.Syscall.Linux.html","title":"Stdio.Syscall.Linux","type":"module"},{"doc":"Terminating descendents of a supervisor process","ref":"Stdio.Syscall.Linux.html#reap/2","title":"Stdio.Syscall.Linux.reap/2","type":"function"},{"doc":"Terminate descendents of a process. reap signals subprocesses of a process identified by PID. If the process called PR_SET_CHILD_SUBREAPER , background and daemonized subprocesses will also be terminated. Note: terminating subprocesses using this method is subject to race conditions: new processes may have been forked processes may have exited and unrelated processes assigned the PID processes may ignore some signals processes may not immediately exit after signalling","ref":"Stdio.Syscall.Linux.html#reap/3","title":"Stdio.Syscall.Linux.reap/3","type":"function"},{"doc":"System call portability for OpenBSD.","ref":"Stdio.Syscall.OpenBSD.html","title":"Stdio.Syscall.OpenBSD","type":"module"},{"doc":"","ref":"Stdio.OpError.html","title":"Stdio.OpError","type":"exception"},{"doc":"","ref":"Stdio.StreamError.html","title":"Stdio.StreamError","type":"exception"},{"doc":"Stream standard I/O from system processes. Reliably reap, restrict and isolate system tasks: Stdio is a control plane for processes. graph LR B([beam]) --&gt;|root| S0[Supervise] B([beam]) --&gt;|user| S1[Supervise] S0 --&gt; |user|I0[[init]] S0 --&gt; |user|I1[[init]] subgraph namespace0 I0 --&gt; C0[[echo 'Hello']] end subgraph namespace1 I1 --&gt; C1[[echo 'System working?']] end S1 --&gt; C2[[echo 'Seems to be.']]","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Stdio is an Elixir library. The package can be installed by adding stdio to your list of dependencies in mix.exs : def deps do [ { :stdio , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"iex&gt; Stdio . stream! ( &quot;echo test&quot; ) |&gt; Enum . to_list ( ) [ stdout : &quot;test \\n &quot; , exit_status : 0 ] Commands use /bin/sh -c : iex&gt; Stdio . stream! ( &quot;pstree $$&quot; ) |&gt; Enum . to_list ( ) [ stdout : &quot;sh---pstree \\n &quot; , exit_status : 0 ] graph LR B([beam]) --&gt;S[Supervise] S --&gt; I[[sh]] I --&gt; C[[pstree]] Pipes Streams can be piped into processes: iex&gt; [ &quot;let&quot; , &quot;it&quot; , &quot;crash&quot; ] |&gt; Stdio . pipe! ( &quot;tr &#39;[a-z]&#39; &#39;[A-Z]&#39;&quot; ) |&gt; Enum . to_list ( ) [ stdout : &quot;LETITCRASH&quot; , exit_status : 0 ] graph LR B([beam]) --&gt;|&quot;[let, it, crash]&quot;|S[Supervise] S --&gt; I[[sh]] I --&gt; |&quot;[let, it, crash]&quot;|C[[&quot;tr '[a-z]' '[A-Z]'&quot;]] C --&gt; O([&quot;LETITCRASH&quot;]) Argument List Commands can executed without an intermediary shell process by using an argv. Since $PATH is not consulted, the path to the executable is required: iex&gt; Stdio . stream! ( [ &quot;/bin/echo&quot; , &quot;test&quot; ] ) |&gt; Enum . to_list ( ) [ stdout : &quot;test \\n &quot; , exit_status : 0 ] graph LR B([beam]) --&gt;S[Supervise] S --&gt; C[[/bin/echo test]] Background Processes Background and daemonized processes are reaped when the foreground process exits: iex&gt; Stdio . stream! ( &quot;sleep 131 &amp; sleep 111 &amp; echo $$&quot; ) |&gt; Enum . to_list ( ) [ stdout : &quot;25723 \\n &quot; , exit_status : 0 ] iex&gt; Stdio.Procfs . children ( 25723 ) [ ] graph LR B([beam]) --&gt;S[Supervise] S -.-x I[[/bin/sh]] I -.-x C0[[sleep 131]] I -.-x C1[[sleep 111]] S --&gt; C0 S --&gt; C1 Setuid Binaries Setuid processes are disabled by default to prevent unkillable processes. iex&gt; Stdio . stream! ( &quot;ping -c 1 8.8.8.8&quot; ) |&gt; Enum . to_list ( ) [ stderr : &quot;ping: ssend socket: Operation not permitted \\n &quot; , exit_status : 71 ] The process can escalate privileges by using the setuid option: iex&gt; Stdio . stream! ( &quot;ping -c 1 8.8.8.8&quot; , Stdio.Process , setuid : true ) |&gt; Enum . to_list ( ) [ stdout : &quot;PING 8.8.8.8 (8.8.8.8): 56 data bytes \\n 64 bytes from 8.8.8.8: icmp_seq=0 ttl=116 time=1.726 ms \\n &quot; , stdout : &quot; \\n --- 8.8.8.8 ping statistics --- \\n 1 packets transmitted, 1 packets received, 0.0% packet loss \\n round-trip min/avg/max/stddev = 1.726/1.726/1.726/0.000 ms \\n &quot; , exit_status : 0 ] Privileges Warning Some behaviours may require running system processes as the root user. For setup, see Stdio.setuid/0 . Behaviours may change the root filesystem for the process. The default chroot(2) directory hierarchy can be created by running: iex&gt; Stdio.Container . make_chroot_tree! ( ) Process Isolation Behaviours can implement process restrictions or process isolation. For example, by default the Stdio.Rootless behaviour does not have network access: iex&gt; Stdio . stream! ( &quot;ip -br addr show&quot; , Stdio.Rootless ) |&gt; Enum . to_list ( ) [ stdout : &quot;lo DOWN \\n &quot; , exit_status : 0 ] graph LR B([beam]) --&gt;|user| S[Supervise] S --&gt; |user|I[[init]] subgraph &quot;user/network namespace&quot; I --&gt; C[[ip -br addr show]] end Linux Container The Stdio.Container behaviour also disables network access: iex&gt; Stdio . stream! ( &quot;ping -c 1 8.8.8.8&quot; , Stdio.Container , setuid : true ) |&gt; Enum . to_list ( ) [ stderr : &quot;ping: connect: Network is unreachable \\n &quot; , exit_status : 2 ] graph LR B([beam]) --&gt;|root| S[Supervise] S --&gt; |user|I[[sh]] subgraph &quot;network namespace&quot; I --&gt; C[[ping -c 1 8.8.8.8]] end If setuid is allowed and the host network is shared, ping works as expected: iex&gt; Stdio . stream! ( &quot;ping -c 1 8.8.8.8&quot; , Stdio.Container , setuid : true , net : :host ) |&gt; Enum . to_list ( ) [ stdout : &quot;PING 8.8.8.8 (8.8.8.8) 56(84) bytes of data. \\n 64 bytes from 8.8.8.8: icmp_seq=1 ttl=115 time=32.4 ms \\n \\n --- 8.8.8.8 ping statistics --- \\n 1 packets transmitted, 1 received, 0% packet loss, time 0ms \\n rtt min/avg/max/mdev = 32.390/32.390/32.390/0.000 ms \\n &quot; , exit_status : 0 ] graph LR B([beam]) --&gt;|root| S[Supervise] S --&gt; |user|I[[sh]] subgraph &quot;namespace (net shared with parent)&quot; I --&gt; C[[ping -c 1 8.8.8.8]] end FreeBSD Jails FreeBSD Jails work in a similar way. An argv is used because the process is chroot(2) 'ed in /rescue , a directory containing statically linked binaries. By default setuid and net are disabled: iex&gt; Stdio . stream! ( [ &quot;./ping&quot; , &quot;-c&quot; , &quot;1&quot; , &quot;8.8.8.8&quot; ] , Stdio.Jail , path : &quot;/rescue&quot; ) |&gt; Enum . to_list ( ) [ stderr : &quot;ping: ssend socket: Protocol not supported \\n &quot; , exit_status : 71 ] graph LR B([beam]) --&gt;|root| S[Supervise] S --&gt; |user|I[[sh]] subgraph &quot;jail&quot; I --&gt; C[[ping -c 1 8.8.8.8]] end","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"inetd An inetd(8) server adapted from the Task and gen_tcp echo server example in the Elixir documentation to fork() a system process. To run from iex: iex&gt; Inetd.Server . start ( [ ...&gt; %{ ip : &quot;::&quot; , port : 7070 , command : &quot;cat -n&quot; } , ...&gt; %{ ip : &quot;127.0.0.1&quot; , port : 7071 , command : &quot;stdbuf -o0 tr [A-Z] [a-z]&quot; } ...&gt; ] ) defmodule Inetd.Server do require Logger def start ( spec ) do children = spec |&gt; Enum . map ( fn %{ port : port , command : command } = m -&gt; { :ok , ip } = :inet_parse . address ( String . to_charlist ( Map . get ( m , :ip , &quot;::&quot; ) ) ) behaviour = Map . get ( m , :behaviour , Stdio.Rootless ) Supervisor . child_spec ( { Task , fn -&gt; Inetd.Server . accept ( ip , port , command , behaviour ) end } , id : { ip , port } , restart : :permanent ) end ) children = [ { Task.Supervisor , name : Inetd.TaskSupervisor } ] ++ children opts = [ strategy : :one_for_one , name : Inetd.Supervisor ] Supervisor . start_link ( children , opts ) end @doc &quot;&quot;&quot; Starts accepting connections on the given `port`. &quot;&quot;&quot; def accept ( ip , port , command , behaviour ) do { :ok , socket } = :gen_tcp . listen ( port , [ :binary , packet : :line , active : false , reuseaddr : true , ip : ip ] ) Logger . info ( &quot;Accepting connections on port \#{ port } &quot; ) loop_acceptor ( socket , command , behaviour ) end defp loop_acceptor ( socket , command , behaviour ) do { :ok , client } = :gen_tcp . accept ( socket ) { :ok , pid } = Task.Supervisor . start_child ( Inetd.TaskSupervisor , fn -&gt; serve ( client , command , behaviour ) end ) :ok = :gen_tcp . controlling_process ( client , pid ) loop_acceptor ( socket , command , behaviour ) end defp serve ( socket , command , behaviour ) do Stream . resource ( fn -&gt; socket end , fn socket -&gt; read_line ( socket ) end , fn socket -&gt; :gen_tcp . close ( socket ) end ) |&gt; Stdio . pipe! ( command , behaviour ) |&gt; Stream . transform ( socket , fn data , socket -&gt; write_line ( data , socket ) end ) |&gt; Stream . run ( ) end defp read_line ( socket ) do case :gen_tcp . recv ( socket , 0 ) do { :ok , data } -&gt; { [ data ] , socket } { :error , _ } -&gt; { :halt , socket } end end defp write_line ( { :stdout , line } , socket ) do case :gen_tcp . send ( socket , line ) do :ok -&gt; { [ ] , socket } { :error , _ } -&gt; { :halt , socket } end end defp write_line ( { :stderr , line } , socket ) do case :gen_tcp . send ( socket , line ) do :ok -&gt; { [ ] , socket } { :error , _ } -&gt; { :halt , socket } end end defp write_line ( { msg , _ } = data , socket ) when msg in [ :exit_status , :termsig ] do Logger . info ( &quot; \#{ inspect ( data ) } &quot; ) { :halt , socket } end end","ref":"readme.html#examples","title":"Overview - Examples","type":"extras"},{"doc":"Documentation is available on hexdocs .","ref":"readme.html#documentation","title":"Overview - Documentation","type":"extras"}]